/*
    This file is part of KitchenSync 

    Copyright (c) 2006 Daniel Gollub <dgollub@suse.de>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef KSYNC_XMLDIFFALGO_H
#define KSYNC_XMLDIFFALGO_H

#include <qdom.h>

#include <libkdepim/diffalgo.h>

using namespace KPIM;

namespace KSync {

class XmlDiffAlgo : public DiffAlgo
{
  public:
    XmlDiffAlgo( const QString &leftXml, const QString &rightXml );
    XmlDiffAlgo( const QDomDocument &leftXml, const QDomDocument &rightXml );

    void run();

  private:
    void appendConflictNodes(QDomElement &leftElement, QDomElement &rightElement);
    void appendSingleNodes(QDomElement &element, bool isLeft);


    void compareNode(QDomElement &leftElement, QDomElement &rightElement);

    QDomDocument mLeftXml;
    QDomDocument mRightXml;
};

}

#endif
